Subject: [bug#71672] [PATCH] python: Prefer python3 over python

From: "Zack Weinberg" <[email-masked]>
Date: Thu, 20 Jun 2024 09:33:14 -0400

On Thu, Jun 20, 2024, at 5:50 AM, Collin Funk wrote:
> Shouldn't AM_PATH_PYTHON check for the python3 command before python?

Yes it should.

> The full recommendation of how these should be setup is in PEP 394

Note that PEP 394 is dangerously incorrect on one point: a system where
/usr/bin/python and/or the bare 'python' command invoke Python 3 is a
misconfigured system, because there's -- yes, even now -- a huge volume
of Python 2-only scripts out there in the wild that will malfunction if
run under a Python 3 interpreter.  In the worst case "malfunction" means
"cause silent data corruption."

This is mostly not Automake's problem, but -- assuming people who use
AM_PATH_PYTHON with current versions of Automake *want* the Python 3
interpreter, for the most part -- it might be an argument for *not*
probing unsuffixed 'python', only 'python3' and 'python3.*'.

zw